
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Snappay mobile payment demo</title>
</head>

<?php
	require_once( 'lib/snappay-sign-utils.php' );

	//MUST keep sign key secretly. Best to load from somewhere else, like database.
	$signKey = '7e2083699dd510575faa1c72f9e35d43';
  $app_id = '9f00cd9a873c511e';

	$trans_amount = $_REQUEST['trans_amount'];
	$payment_method = $_REQUEST['payment_method'];
	$out_order_no = $_REQUEST['out_order_no'];
	$notify_url = $_REQUEST['notify_url'];
	$return_url = $_REQUEST['return_url'];
	$description = $_REQUEST['description'];
	$merchant_no = $_REQUEST['merchant_no'];

	$post_data = array(
        'app_id' => $app_id,
        'format' => 'JSON',
        'charset' => 'UTF-8',
        'sign_type' => 'MD5',
        'version' => '1.0',

        'method' => 'pay.h5pay',
        'merchant_no' => $merchant_no,
        'payment_method' => $payment_method,
        'out_order_no' => $out_order_no,
        'trans_amount' => $trans_amount,
        'notify_url' => $notify_url,
        'return_url' => $return_url,
        'description' => $description,
        'pay_channel_trade_type' => 'ORDERSTR'
    );

	$post_data_sign = snappay_sign_post_data($post_data, $signKey);

	//echo print_r($post_data_sign);

	$url = 'https://open.snappay.ca/api/gateway';

	$options = array(
		'http' => array(
		    'method'  => 'POST',
		    'header'  =>  "Content-Type: application/json\r\n"."Accept: application/json\r\n",
		    'content' => json_encode($post_data_sign)
		)
	);
	$context  = stream_context_create($options);
	$result = file_get_contents($url, false, $context);
	if ($result === FALSE) {  
		//Handle error  
	}

	//var_dump($result);

	$result_json = json_decode($result, true);
	if($result_json['code'] === '0'){
		$order_str = $result_json['data'][0]['order_str'];
		//echo print_r($order_str);
	}

?>

<body>
	<h1>点击以下按钮唤起收银台支付</h1>
    <button onclick="go()">订单串唤起支付</button>
<script>
function ready(callback) {
	// 如果jsbridge已经注入则直接调用
	if (window.AlipayJSBridge) {
		callback && callback();
	} else {
		// 如果没有注入则监听注入的事件
		document.addEventListener('AlipayJSBridgeReady', callback, false);
	}
}
function go(){
    ready(function(){
	    AlipayJSBridge.call("tradePay", {
	      orderStr: "<?php echo $order_str ?>"
	    }, function(result) {
	      //alert(JSON.stringify(result));
	    });
    });
}
</script>
</body>
</html>
