<?php
	require_once( 'lib/snappay-sign-utils.php' );

	//MUST keep sign key secretly. Best to load from somewhere else, like database.

	if(!isset($_REQUEST['sign_key']) || !isset($_REQUEST['sign_string']) 
		|| empty($_REQUEST['sign_key']) || empty($_REQUEST['sign_string'])
		){
		echo 'sign_string, sign_key can\'t be null'; 
	}else{
		$sign_string = $_REQUEST['sign_string'];
		$sign_key = $_REQUEST['sign_key'];

		$post_data = array(
	            'charset' => 'UTF-8',
	            'version' => '1.0',
	            'sign_type' => 'MD5',

	            'out_order_no' => $out_order_no,
	            'merchant_no' => $merchant_no,
	            'method' => 'pay.notify',
	            'trans_status' => 'SUCCESS'
	        );

		$post_data_sign = snappay_sign_post_data($post_data, $signKey);

		//echo print_r($post_data_sign);

		$url = $notify_url;

		$options = array(
		  'http' => array(
		    'method'  => 'POST',
		    'content' => json_encode( $post_data_sign ),
		    'header'  =>  "Content-Type: application/json\r\n"."Accept: application/json\r\n"
		    )
		);

		$context  = stream_context_create( $options );
		$result = file_get_contents( $url, false, $context );
		echo $result;

	}

?>
