<?php
	//merchant back-end code, call snappay OpenAPI unitedpay

	require_once( 'lib/snappay-sign-utils.php' );

	//MUST keep sign key secretly.
	$signKey = '7e2083699dd510575faa1c72f9e35d43';
	$app_id = '9f00cd9a873c511e';

	$trans_amount = $_REQUEST['trans_amount'];
	$notify_url = $_REQUEST['notify_url'];
	$description = $_REQUEST['description'];
	$merchant_no = $_REQUEST['merchant_no'];
	
	$return_url = $_POST['return_url'];

	$out_order_no = '1';
	if(isset($_REQUEST['out_order_no'])){
		$out_order_no = $_REQUEST['out_order_no'];
	}else{
		$milliseconds = round(microtime(true) * 1000);
		$milliseconds = substr($milliseconds, 3);
		$randnum = rand(100, 999);
		$out_order_no = $milliseconds.$randnum;
	}

	$post_data = array(
            'app_id' => $app_id,
            'format' => 'JSON',
            'charset' => 'UTF-8',
            'sign_type' => 'MD5',
            'version' => '1.0',

            'method' => 'pay.unitedpay',
            'merchant_no' => $merchant_no,
            'out_order_no' => $out_order_no,
            'trans_amount' => $trans_amount,
            'notify_url' => $notify_url,
            'return_url' => $return_url,
            'description' => $description
        );

	$post_data_sign = snappay_sign_post_data($post_data, $signKey);

	//echo print_r($post_data_sign);

	$url = 'https://open.snappay.ca/api/gateway';

	$options = array(
		'http' => array(
		    'method'  => 'POST',
		    'header'  =>  "Content-Type: application/json\r\n"."Accept: application/json\r\n",
		    'content' => json_encode($post_data_sign)
		)
	);
	$context  = stream_context_create($options);
	$result = file_get_contents($url, false, $context);
	if ($result === FALSE) {  
		//Handle error  
	}

	$result_json = json_decode($result, true);
	if($result_json['code'] === '0'){
		$redirect_url = $result_json['data'][0]['redirect_url'];
		//echo print_r($redirect_url);
		header('Location: '.$redirect_url);
		exit();
	}

	var_dump($result);
?>
