<?php
	//SnapPay fron-end payment page, call SnapPay unitedpaycreate API

	$isMobile = 'false';
	if (isset($_SERVER['HTTP_X_WAP_PROFILE'])) {
        $isMobile = 'true';
    }
    if (isset($_SERVER['HTTP_VIA'])) {
    	if(stristr($_SERVER['HTTP_VIA'], "wap")){
    		 $isMobile = 'true';
    	}
    }
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
        $clientkeywords = array('nokia','sony','samsung','htc','lg','lenovo','iphone','blackberry','meizu','android','netfront','ucweb','windowsce','palm','operamini','operamobi','openwave','nexus','pixel','wap','mobile','MicroMessenger','AlipayClient','HUAWEI','XiaoMi','OPPO','vivo');
        if (preg_match("/(" . implode('|', $clientkeywords) . ")/i", strtolower($_SERVER['HTTP_USER_AGENT']))) {
            $isMobile = 'true';
        }
    }
    if (isset ($_SERVER['HTTP_ACCEPT'])) {
        if ( (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && 
            (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || 
                (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html'))) ) {
            $isMobile = 'true';
        }
    }

	$token = $_REQUEST['token'];

	$url = 'https://payprod.pre.snappay.ca/api/mobileapp/pay/unitedpaycreate?token='.$token.'&isMobile='.$isMobile;

	$result = file_get_contents($url);

	$result_json = json_decode($result, true);

	$method = '';
	$payment_method = '';
	$qrcode_url = '';
	$h5pay_url = '';

	if($result_json['code'] === '0'){
		$method = $result_json['data'][0]['method'];
		$payment_method = $result_json['data'][0]['payment_method'];
		if ($method === 'pay.qrcodepay'){
			$qrcode_url = $result_json['data'][0]['qrcode_url'];
		} else if ($method === 'pay.h5pay'){
			$h5pay_url = $result_json['data'][0]['h5pay_url'];
			header('Location: '.$h5pay_url);
			exit();
		}
    }
    
    var_dump($result);
?>

<body>
	<?php 
	if($result_json['code'] !== '0'){
		echo 'Create order fail. [' . $result_json['msg'] . ']';
	} else {
	?>

	<h>Please scan QR code with <?php echo $payment_method ?> </h>
	<br><br>
	<div id="code"></div> 
	<script type="text/javascript" src="lib/jquery-3.3.1.min.js"></script> 
	<script type="text/javascript" src="lib/jquery.qrcode.min.js"></script> 
	<script type="text/javascript">
		$("#code").qrcode({ 
		    width: 200,
		    height:200,
		    text: "<?php echo $qrcode_url ?>"
		}); 
	</script> 

	<p>Transaction status: <span class="status"></span></p>

	<script>
        (function() {
            var token = "<?php echo $token ?>";
            var counter =0;
            var pollingurl = "queryorder.php?token="+token;
            var status = $('.status'),
                poll = function() {
                    status.text('Waiting ...');
                    console.log("waiting counter: " + counter);
                    if (counter++ >  30) { // timeout after 30 times
                        status.text(" TIMEOUT !!!  "); // timeout
                        clearInterval(pollInterval); // optional: stop poll function
                        console.log("waiting for user confirm transaction is timeout  " + " === ");
                    } else {
                        $.ajax({
                            url: pollingurl,
                            dataType: 'json',
                            type: 'get',
                            success: function(data) { 
								// check if it is available
								console.log("data.data[0].trans_status: " + data.data[0].trans_status);
                                if ( data.data[0].trans_status == 'SUCCESS' ) { // get and check data value
                                    status.text(data.data[0].trans_status); // get and print data string
                                    clearInterval(pollInterval); // optional: stop poll function
                                    console.log("queryorder.jsp return success " + " === ");
                                    window.location.replace(data.data[0].return_url);
                                } else {
                                    status.text(data.data[0].trans_status);
                                    console.log("queryorder.jsp return not success   " + " === ");
                                }
                            },
                            error: function(xhr, status, error) { // error logging
                            	console.log(xhr);
                                var err = eval("(" + xhr.responseText + ")");
                                console.log(err.Message);
                            }
                        });
                    }

                };

            poll(); // also run function on init
            pollInterval = setInterval(function() { // run function every 5000 ms
                poll();
            }, 5000);
        })();
    </script>

	<?php	
	}
	?>
	
</body>
</html>
