
<html>
<head>
    <title>Return Url Page</title>
</head>
<body>

<?php

	//merchant back-end code, call snappay OpenAPI query

	require_once( 'lib/snappay-sign-utils.php' );

	//MUST keep sign key secretly.
	$signKey = '7e2083699dd510575faa1c72f9e35d43';
	$app_id = '9f00cd9a873c511e';
	$merchant_no = '901800000116';

	if(empty($_REQUEST['out_order_no'])){
		echo 'order_no can\'t be null'; 
	}else{
		$out_order_no = $_REQUEST['out_order_no'];

		$post_data = array(
            'app_id' => $app_id,
            'format' => 'JSON',
            'charset' => 'UTF-8',
            'sign_type' => 'MD5',
            'version' => '1.0',

			'method' => 'pay.orderquery',
            'out_order_no' => $out_order_no,
            'merchant_no' => $merchant_no
        );

		$post_data_sign = snappay_sign_post_data($post_data, $signKey);

		//echo print_r($post_data_sign);

		$url = 'https://open.snappay.ca/api/gateway';

		$options = array(
			'http' => array(
			    'method'  => 'POST',
			    'header'  =>  "Content-Type: application/json\r\n"."Accept: application/json\r\n",
			    'content' => json_encode($post_data_sign)
		    )
		);
		$context  = stream_context_create($options);
		$result = file_get_contents($url, false, $context);
		if ($result === FALSE) { 
			//Handle error 
		}

		//var_dump($result);

		$result_json = json_decode($result, true);
		if($result_json['code'] === '0'){
			$trans_status = $result_json['data'][0]['trans_status'];
			//echo print_r($redirect_url);
			if($trans_status === 'SUCCESS '){
				/*
			     * do business logic here, update order complete, redircet Thank you page.
			     */
			} 
			echo $trans_status;
		} else {
			echo $result_json['msg'];
		}

	}
?>
</body>
</html>
